package com.abc.hortnetq;

import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.Destination;
import javax.jms.JMSException;
import javax.jms.MessageProducer;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.naming.InitialContext;
import javax.naming.NamingException;

/**
 *
 * @author ahartner
 */
public class ClientSender {

  public static void main(String[] args) throws NamingException, JMSException {
    InitialContext initialContext = null;
    Connection connection = null;
    int index=0;
    try {
      Properties props = new Properties();
      
      initialContext = new InitialContext(props);
      ConnectionFactory connectionFactory = (ConnectionFactory) initialContext.lookup("/ExampleConnectionFactory");
      connection = connectionFactory.createConnection();
      connection.start();
      //Destination topic = (Destination)initialContext.lookup("/topic/ExampleTopic");
      Destination queue = (Destination)initialContext.lookup("/queue/exampleQueue");
      //Destination autoQueue = (Destination)initialContext.lookup("/queue/AutoPickupQueue");
      
      Session session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
      MessageProducer producer = session.createProducer(queue);
      long start=System.currentTimeMillis();
      long before = start;
      for (index=0; index<10000; index++)
      {
        try
        {
        TextMessage message = session.createTextMessage("Message :"+index);
        producer.send(message);
//        System.out.println("Sent : "+message.getText());
//        Thread.sleep(100);
          if (index%1000==0)
          {                       
            long now=System.currentTimeMillis();        
            System.out.println("SENDING : Time taken : "+(now-before));
            before = now;
          }
        }
        catch (Exception e)
        {
          System.err.println("Exception "+e.getMessage()+" during sending");
          Thread.sleep(5000);
        }
      }
      producer.send(session.createTextMessage("Message : XXX"));      
      producer.close();      
    } catch (Exception e) {
      Logger.getLogger(Node.class.getName()).log(Level.SEVERE, null, e);
    } finally {
      if (initialContext != null) {
        initialContext.close();
      }
         if (connection != null)
         {
            connection.close();
         }
    }
    System.out.println("Sent : "+index+" messages");
  }
}
